<?php if (!defined('PmWiki')) exit();

$BlockMarkups['gl'] = array('<tbook:glossary>','</tbook:item>','</tbook:item></tbook:glossary>',1);
Markup('^G::','<^::','/^(:)(\s*)([^:"\s]+)\s*(?:"(.*?)"(?:(.*?)")?)?:/',
  "tbgtermHelper");
function tbgtermHelper($m) {
  return $GLOBALS['Glossary']   ? 
    '<:gl,'.$m[1].','.$m[1].$m[2].'><tbook:term id="'.$m[3].'">'.$m[2].
    ($m[4] ? $m[4] : GlossSpaced($m[3])).
    (SeenGlossItem($m[3]) ? ' (<tbook:pageref refid="'.$m[3].':1">p</tbook:pageref>)' : '').
    '</tbook:term><tbook:item>' : $m[0];
}

Markup_e('gls','inline',
  "/([Gg])ls(p?)\((?:\"(\\w[-\\w]*)\")?\\s*(\\w[-\\w]*)\\s*\)(['\\w]*)/",
  "'<tbook:gloss refid=\"'.\$m[4].'\" id=\"'.GlossaryLinkID(\$m[4]).'\">'.GlossaryLinkText(\$pagename, \$m[1], \$m[2], \$m[3], \$m[4], \$m[5]).'</tbook:gloss>'");
Markup_e('glsa','directives',"/gls\(\\s*`(\\w[-\\w]*)\\s*\)(['\\w]*)/",
  "'<tbook:gloss refid=\"'.\$m[1].'\" id=\"'.GlossaryLinkID(\$m[1]).'\">'.AbbreviationGlossaryText(\$pagename, \$m[1], \$m[2]).'</tbook:gloss>'");
function GlossaryLinkID($key) {
  global $SeenGlossLink;
  $i = @$SeenGlossLink[$key] + 1;
  return "$key:$i";
}
function SeenGlossItem($key) {
  global $SeenGlossLink, $SeenAbbr;
  return (@$SeenGlossLink[$key] || @$SeenAbbr[$key]);
}
Markup('^G:','block','/^G:\s*(.*?)$/',
  (($_GET['ptype']=='book') ? '<:block,1><tbook:h level="1">$1</tbook:h>'
                            : '<:block,1><tbook:h level="2">$1</tbook:h>'));
$GlossaryTag = array('open'  => '<theglossary>', 
                     'head'  => '<h level="'.(($_GET['ptype']=='book') ? '0' : '1').'">$Page</h>'."\n",
                     'break' => 'G: $Letter'."\n\n",
                     'close' => '</theglossary>');

?>
